var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var EwsLogging_1 = require("../Core/EwsLogging");
var XmlNamespace_1 = require("../Enumerations/XmlNamespace");
var ComplexPropertyDefinition_1 = require("./ComplexPropertyDefinition");
var ContainedPropertyDefinition = (function (_super) {
    __extends(ContainedPropertyDefinition, _super);
    function ContainedPropertyDefinition(propertyName, xmlElementName, containedXmlElementName, version, uri, flags, propertyCreationDelegate) {
        _super.call(this, propertyName, xmlElementName, version, uri, flags, propertyCreationDelegate);
        EwsLogging_1.EwsLogging.Assert(propertyCreationDelegate != null, "ComplexPropertyDefinition ctor", "CreateComplexPropertyDelegate cannot be null");
        this.containedXmlElementName = containedXmlElementName;
    }
    ContainedPropertyDefinition.prototype.InternalLoadFromXmlJsObject = function (jsObject, service, propertyBag) {
        //debug: //check for correct contained element name
        if (jsObject[this.containedXmlElementName]) {
            jsObject = jsObject[this.containedXmlElementName];
        }
        _super.prototype.InternalLoadFromXmlJsObject.call(this, jsObject, service, propertyBag);
        //reader.ReadStartElement(XmlNamespace.Types, this.containedXmlElementName);
        //
        //base.InternalLoadFromXml(reader, propertyBag);
        //
        //reader.ReadEndElementIfNecessary(XmlNamespace.Types, this.containedXmlElementName);
    };
    ContainedPropertyDefinition.prototype.WritePropertyValueToXml = function (writer, propertyBag, isUpdateOperation) {
        var complexProperty = propertyBag._getItem(this);
        if (complexProperty != null || typeof complexProperty !== 'undefined') {
            writer.WriteStartElement(XmlNamespace_1.XmlNamespace.Types, this.XmlElementName);
            complexProperty.WriteToXml(writer, this.containedXmlElementName);
            writer.WriteEndElement(); // this.XmlElementName
        }
        //throw new Error("ContainedPropertyDefinition.ts - WritePropertyValueToXml : Not implemented."); 
    };
    return ContainedPropertyDefinition;
})(ComplexPropertyDefinition_1.ComplexPropertyDefinition);
exports.ContainedPropertyDefinition = ContainedPropertyDefinition;
