var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var ExchangeVersion_1 = require("../Enumerations/ExchangeVersion");
var XmlElementNames_1 = require("../Core/XmlElementNames");
var DefaultExtendedPropertySet_1 = require("../Enumerations/DefaultExtendedPropertySet");
var MapiPropertyType_1 = require("../Enumerations/MapiPropertyType");
var XmlNamespace_1 = require("../Enumerations/XmlNamespace");
var XmlAttributeNames_1 = require("../Core/XmlAttributeNames");
var ExtensionMethods_1 = require("../ExtensionMethods");
var PropertyDefinitionBase_1 = require("./PropertyDefinitionBase");
//should be done
var ExtendedPropertyDefinition = (function (_super) {
    __extends(ExtendedPropertyDefinition, _super);
    function ExtendedPropertyDefinition(tag, name, mapiType, propertySet) {
        _super.call(this);
        this.tag = tag || 0;
        this.mapiType = mapiType || MapiPropertyType_1.MapiPropertyType.String;
        this.propertySet = propertySet;
        this.name = name;
    }
    Object.defineProperty(ExtendedPropertyDefinition.prototype, "Id", {
        get: function () { return this.id; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExtendedPropertyDefinition.prototype, "MapiType", {
        get: function () { return this.mapiType; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExtendedPropertyDefinition.prototype, "Name", {
        get: function () { return this.name; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExtendedPropertyDefinition.prototype, "PropertySet", {
        get: function () { return this.propertySet; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExtendedPropertyDefinition.prototype, "PropertySetId", {
        get: function () { return this.propertySetId; } //System.Guid
        ,
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExtendedPropertyDefinition.prototype, "Tag", {
        get: function () { return this.tag; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ExtendedPropertyDefinition.prototype, "Version", {
        get: function () { return ExchangeVersion_1.ExchangeVersion.Exchange2007_SP1; },
        enumerable: true,
        configurable: true
    });
    //AddJsonProperties(jsonPropertyDefinition: JsonObject, service: ExchangeService): any { throw new Error("ExtendedPropertyDefinition.ts - AddJsonProperties : Not implemented."); }
    ExtendedPropertyDefinition.prototype.Equals = function (obj) {
        var propertyDefinition = obj;
        return ExtendedPropertyDefinition.IsEqualTo(propertyDefinition, this);
    };
    ExtendedPropertyDefinition.prototype.FormatField = function (name, fieldValue) {
        debugger;
        return (fieldValue != null)
            ? ExtensionMethods_1.StringHelper.Format(ExtendedPropertyDefinition.FieldFormat, name, fieldValue)
            : "";
    };
    ExtendedPropertyDefinition.prototype.GetHashCode = function () { throw new Error("ExtendedPropertyDefinition.ts - GetHashCode : Not implemented."); };
    //GetJsonType(): string { throw new Error("ExtendedPropertyDefinition.ts - GetJsonType : Not implemented."); }
    ExtendedPropertyDefinition.prototype.GetPrintableName = function () {
        debugger;
        var sb = "";
        sb += "{";
        sb += this.FormatField(ExtendedPropertyDefinition.NameFieldName, this.Name);
        sb += this.FormatField(ExtendedPropertyDefinition.MapiTypeFieldName, MapiPropertyType_1.MapiPropertyType[this.MapiType]);
        sb += this.FormatField(ExtendedPropertyDefinition.IdFieldName, this.Id.toString());
        sb += this.FormatField(ExtendedPropertyDefinition.PropertySetFieldName, DefaultExtendedPropertySet_1.DefaultExtendedPropertySet[this.PropertySet]);
        //sb += FormatField < Guid?> (PropertySetIdFieldName, this.PropertySetId);
        sb += this.FormatField(ExtendedPropertyDefinition.PropertySetIdFieldName, this.PropertySetId.ToString ? this.PropertySetId.ToString() : this.PropertySetId);
        sb += this.FormatField(ExtendedPropertyDefinition.TagFieldName, this.Tag.toString());
        sb += "}";
        return sb;
    };
    ExtendedPropertyDefinition.prototype.GetXmlElementName = function () { return XmlElementNames_1.XmlElementNames.ExtendedFieldURI; };
    ExtendedPropertyDefinition.IsEqualTo = function (extPropDef1, extPropDef2) {
        return;
        extPropDef1, extPropDef2 ||
            (extPropDef1 && extPropDef2 &&
                extPropDef1.Id == extPropDef2.Id &&
                extPropDef1.MapiType == extPropDef2.MapiType &&
                extPropDef1.Tag == extPropDef2.Tag &&
                extPropDef1.Name == extPropDef2.Name &&
                extPropDef1.PropertySet == extPropDef2.PropertySet &&
                extPropDef1.propertySetId == extPropDef2.propertySetId);
    };
    //LoadFromJson(jsonObject: JsonObject): any { throw new Error("ExtendedPropertyDefinition.ts - LoadFromJson : Not implemented."); }
    ExtendedPropertyDefinition.prototype.LoadPropertyValueFromXmlJsObject = function (jsObject) {
        for (var key in jsObject) {
            switch (key) {
                case XmlAttributeNames_1.XmlAttributeNames.DistinguishedPropertySetId:
                    debugger;
                    this.propertySet = isNaN(jsObject[key]) ? DefaultExtendedPropertySet_1.DefaultExtendedPropertySet[jsObject[key]] : +(jsObject[key]); // jsObject.ReadEnumValue<DefaultExtendedPropertySet>(key);
                    break;
                case XmlAttributeNames_1.XmlAttributeNames.PropertySetId:
                    debugger;
                    this.propertySetId = jsObject[key]; // new Guid(jsObject.ReadAsString(key));
                    break;
                case XmlAttributeNames_1.XmlAttributeNames.PropertyTag:
                    this.tag = ExtensionMethods_1.Convert.toNumber(jsObject[key]); //Convert.ToUInt16(jsObject.ReadAsString(key), 16);
                    break;
                case XmlAttributeNames_1.XmlAttributeNames.PropertyName:
                    this.name = jsObject[key]; //jsObject.ReadAsString(key);
                    break;
                case XmlAttributeNames_1.XmlAttributeNames.PropertyId:
                    this.id = ExtensionMethods_1.Convert.toInt(jsObject[key]); //jsObject.ReadAsInt(key);
                    break;
                case XmlAttributeNames_1.XmlAttributeNames.PropertyType:
                    this.mapiType = isNaN(jsObject[key]) ? MapiPropertyType_1.MapiPropertyType[jsObject[key]] : +(jsObject[key]); // jsObject.ReadEnumValue<MapiPropertyType>(key);
                    break;
                default:
                    break;
            }
        }
    };
    ExtendedPropertyDefinition.prototype.LoadFromXml = function (reader) {
        var attributeValue;
        attributeValue = reader.ReadAttributeValue(XmlNamespace_1.XmlNamespace.NotSpecified, XmlAttributeNames_1.XmlAttributeNames.DistinguishedPropertySetId);
        if (!ExtensionMethods_1.StringHelper.IsNullOrEmpty(attributeValue)) {
            this.propertySet = DefaultExtendedPropertySet_1.DefaultExtendedPropertySet[attributeValue];
        }
        attributeValue = reader.ReadAttributeValue(XmlNamespace_1.XmlNamespace.NotSpecified, XmlAttributeNames_1.XmlAttributeNames.PropertySetId);
        if (!ExtensionMethods_1.StringHelper.IsNullOrEmpty(attributeValue)) {
            this.propertySetId = attributeValue; // new Guid(attributeValue);
        }
        attributeValue = reader.ReadAttributeValue(XmlNamespace_1.XmlNamespace.NotSpecified, XmlAttributeNames_1.XmlAttributeNames.PropertyTag);
        if (!ExtensionMethods_1.StringHelper.IsNullOrEmpty(attributeValue)) {
            this.tag = +(attributeValue); // Convert.ToUInt16(attributeValue, 16);
        }
        this.name = reader.ReadAttributeValue(XmlNamespace_1.XmlNamespace.NotSpecified, XmlAttributeNames_1.XmlAttributeNames.PropertyName);
        attributeValue = reader.ReadAttributeValue(XmlNamespace_1.XmlNamespace.NotSpecified, XmlAttributeNames_1.XmlAttributeNames.PropertyId);
        if (!ExtensionMethods_1.StringHelper.IsNullOrEmpty(attributeValue)) {
            this.id = +(attributeValue); // int.Parse(attributeValue);
        }
        this.mapiType = MapiPropertyType_1.MapiPropertyType[reader.ReadAttributeValue(XmlNamespace_1.XmlNamespace.NotSpecified, XmlAttributeNames_1.XmlAttributeNames.PropertyType)];
    };
    ExtendedPropertyDefinition.prototype.WriteAttributesToXml = function (writer) {
        if (this.propertySet) {
            writer.WriteAttributeValue("", XmlAttributeNames_1.XmlAttributeNames.DistinguishedPropertySetId, this.propertySet);
        }
        if (this.propertySetId) {
            writer.WriteAttributeValue("", XmlAttributeNames_1.XmlAttributeNames.PropertySetId, this.propertySetId.ToString());
        }
        if (this.tag) {
            writer.WriteAttributeValue("", XmlAttributeNames_1.XmlAttributeNames.PropertyTag, this.tag);
        }
        if (!ExtensionMethods_1.StringHelper.IsNullOrEmpty(this.name)) {
            writer.WriteAttributeValue("", XmlAttributeNames_1.XmlAttributeNames.PropertyName, this.name);
        }
        if (this.id) {
            writer.WriteAttributeValue("", XmlAttributeNames_1.XmlAttributeNames.PropertyId, this.id);
        }
        writer.WriteAttributeValue("", XmlAttributeNames_1.XmlAttributeNames.PropertyType, this.mapiType);
    };
    ExtendedPropertyDefinition.FieldFormat = "{0}: {1} ";
    ExtendedPropertyDefinition.PropertySetFieldName = "PropertySet";
    ExtendedPropertyDefinition.PropertySetIdFieldName = "PropertySetId";
    ExtendedPropertyDefinition.TagFieldName = "Tag";
    ExtendedPropertyDefinition.NameFieldName = "Name";
    ExtendedPropertyDefinition.IdFieldName = "Id";
    ExtendedPropertyDefinition.MapiTypeFieldName = "MapiType";
    return ExtendedPropertyDefinition;
})(PropertyDefinitionBase_1.PropertyDefinitionBase);
exports.ExtendedPropertyDefinition = ExtendedPropertyDefinition;
